// API - Any Device - Any OS
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/api/gsc_irq.h $
// $Rev: 23674 $
// $Date: 2013-10-31 16:25:34 -0500 (Thu, 31 Oct 2013) $

#ifndef __GSC_IRQ_H__
#define __GSC_IRQ_H__

#include "gsc_event.h"		/*lint !e537 */



/* #defines	*****************************************************************/

// These are used as index values.
#define	GSC_MAIN_INT_DMA_0		0
#define	GSC_MAIN_INT_DMA_1		1
#define	GSC_MAIN_INT_LOCAL		2

#define	GSC_MAIN_INT_QTY_MAX	3

#define	GSC_LOCAL_INT_QTY_MAX	32	/* REWORK required if made larger than 32. */



/* typedefs	*****************************************************************/

typedef struct
{
	int	dma0;
	int	dma1;
	int	local;
} gsc_irq_src_t;

typedef struct
{
	// All fields are filled in by common code.
	gsc_device_t*	device;		// Passed to OS API.
	gsc_irq_src_t	src;		// Set of IRQ's of interest.
	gsc_event_t*	pci;							// PCI IRQ processing.
	gsc_event_t*	main[GSC_MAIN_INT_QTY_MAX];		// Main IRQ processing.
	gsc_event_t*	local[GSC_LOCAL_INT_QTY_MAX];	// Local IRQ processing.
} gsc_irq_t;



/* prototypes	*************************************************************/

U32		gsc_irq_create(gsc_irq_t* irq, gsc_device_t* device);
void	gsc_irq_destroy(gsc_irq_t* irq);
U32		gsc_irq_disable(gsc_irq_t* irq);
U32		gsc_irq_enable(gsc_irq_t* irq);
U32		gsc_irq_local_create(gsc_irq_t* irq, const char* name, U32 int_id, gsc_event_t** local);
U32		gsc_irq_local_wait(gsc_irq_t* irq, U32 mask, U32 timeout_ms);
U32		gsc_irq_main_create(gsc_irq_t* irq, const char* name, U32 int_id, gsc_event_t** main);



#endif
