// API - Any Device - Linux
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/api/gsc_os_error.c $
// $Rev: 23674 $
// $Date: 2013-10-31 16:25:34 -0500 (Thu, 31 Oct 2013) $

#include "gsc_os_error.h"

#include <errno.h>



/*****************************************************************************
*
*	Function:	os_errno_2_status
*
*	Purpose:
*
*		Convert an errno value to a status value.
*
*	Arguments:
*
*		error		The errno value to convert.
*
*	Returned:
*
*		GSC_SUCCESS	All went well.
*		else		An appropriate error code.
*
*****************************************************************************/

U32 os_errno_2_status(int error)
{
	U32	status;

	switch (error)
	{
		default:			status	= GSC_FAILED;					break;
		case 0:				status	= GSC_SUCCESS;					break;
		case EACCES:		status	= GSC_ACCESS_DENIED;			break;
		case EAGAIN:		status	= GSC_ACCESS_DENIED;			break;
		case EBADF:			status	= GSC_INVALID_HANDLE;			break;
		case EEXIST:		status	= GSC_INTERNAL_ERROR;			break;
		case EFAULT:		status	= GSC_INVALID_DATA;				break;
		case EINTR:			status	= GSC_FAILED;					break;
		case EINVAL:		status	= GSC_INVALID_DATA;				break;
		case EIO:			status	= GSC_FAILED;					break;
		case EISDIR:		status	= GSC_ACCESS_DENIED;			break;
		case ELOOP:			status	= GSC_ACCESS_DENIED;			break;
		case EMFILE:		status	= GSC_INSUFFICIENT_RESOURCES;	break;
		case ENAMETOOLONG:	status	= GSC_INTERNAL_ERROR;			break;
		case ENFILE:		status	= GSC_INSUFFICIENT_RESOURCES;	break;
		case ENODEV:		status	= GSC_ACCESS_DENIED;			break;
		case ENOENT:		status	= GSC_ACCESS_DENIED;			break;
		case ENOMEM:		status	= GSC_INSUFFICIENT_RESOURCES;	break;
		case ENOSPC:		status	= GSC_INSUFFICIENT_RESOURCES;	break;
		case ENOTDIR:		status	= GSC_ACCESS_DENIED;			break;
		case ENOTTY:		status	= GSC_INVALID_HANDLE;			break;
		case ENXIO:			status	= GSC_ACCESS_DENIED;			break;
		case EROFS:			status	= GSC_ACCESS_DENIED;			break;
		case ETXTBSY:		status	= GSC_ACCESS_DENIED;			break;
	}

	return(status);
}



