#include "hpdi32_dsl.h"

#include <stdio.h>

U32	hpdi32_dsl_irq_fifo_full_wait(
	void*	handle,
	U32		timeout_ms,
	int		verbose)
{
	U32	status;

	status	= hpdi32_irq_wait(	handle,
								HPDI32_WHICH_IRQ_TX_F |
								HPDI32_WHICH_IRQ_RX_F,
								timeout_ms);

	if (!verbose)
	{
	}
	else if (status == GSC_SUCCESS)
	{
		printf("Tx/Rx FIFO Full Wait: interrupt occurred.\n");
	}
	else if (status == GSC_WAIT_TIMEOUT)
	{
		printf(	"Tx/Rx FIFO Full Wait: "
				"timeout after %ld milliseconds\n",
				(long) timeout_ms);
	}
	else
	{
		printf("hpdi32_irq_wait() failure: %ld\n", (long) status);
	}

	return(status);
}
