// Utils - HPDI32 - Any OS
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/util_open.c $
// $Rev: 23665 $
// $Date: 2013-10-31 16:20:26 -0500 (Thu, 31 Oct 2013) $

#include "hpdi32_utils.h"

#include <stdio.h>



/*****************************************************************************
*
*	Function:	dev_open
*
*	Purpose:
*
*		Implement a wrapper around the similarly named HPDI32 function.
*
*	Arguments:
*
*		index	The index of the board to open.
*
*		dev		The device handle is recorded here.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
*****************************************************************************/

int dev_open(U8 index, void** dev)
{
	char	buf[64];
	int		errs	= 0;
	U32		status;

	sprintf(buf, "Opening HPDI32 #%d", (int) index);
	label_text(buf);
	status	= hpdi32_open(index, dev);
	errs	= label_fail_func(1, "hpdi32_open", status);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


