// Utils - HPDI32 - Any OS
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/util_status.c $
// $Rev: 23665 $
// $Date: 2013-10-31 16:20:26 -0500 (Thu, 31 Oct 2013) $

#include "hpdi32_utils.h"

#include <stdio.h>



/*****************************************************************************
*
*	Function:	dev_api_status
*
*	Purpose:
*
*		Make sure the API is OK to use.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		>= 0	The number of errors encountered.
*
*****************************************************************************/

int dev_api_status(void)
{
	U32		arg;
	char	buf[256];
	int		errs;
	U32		stat;
	U32		status;
	char	sts[256];

	label_text("HPDI32 API Library status");
	stat	= hpdi32_api_status(&status, &arg, HPDI32_API_VERSION);
	errs	= label_fail_func(1, "hpdi32_api_status", stat);

	if (errs)
	{
	}
	else if (status != GSC_SUCCESS)
	{
		hpdi32_status_text(status, buf, sizeof(buf));
		sprintf(sts, "%s, arg 0x%lX", buf, (long) arg);
		errs	= label_fail_text(1, sts);
	}
	else
	{
		errs	= 0;
		printf("PASS\n");
	}

	return(errs);
}


