// Utils - HPDI32 - Any OS
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/util_tx_auto_stop.c $
// $Rev: 23665 $
// $Date: 2013-10-31 16:20:26 -0500 (Thu, 31 Oct 2013) $

#include "hpdi32_utils.h"

#include <stdio.h>



//*****************************************************************************
int dev_tx_auto_stop(void* dev, int index, int verbose, unsigned long set, unsigned long* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr;
	U32			status;

	if (verbose)
		label_text_index("Tx Auto Stop", index);

	status	= hpdi32_config(dev, HPDI32_TX_AUTO_STOP, 0, set, &set);
	errs	= (status == GSC_SUCCESS) ? 0 : 1;

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case HPDI32_TX_AUTO_STOP_NO:

			ptr	= "No";
			break;

		case HPDI32_TX_AUTO_STOP_YES:

			ptr	= "Yes";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


